"use strict";

jQuery(document).ready(function ($) {

    $(document).on('change', '.wgbl-rule-product-buy-product-item', function () {
        let ruleID = $(this).closest('.wgbl-rule-item').attr('data-id');
        let productBuyID = $(this).closest('.wgbl-rule-item-sortable-item').attr('data-id');
        $(this).closest('.wgbl-rule-item-sortable-item').find('.wgbl-product-buy-extra-fields').html(wgblSetProductBuyFields($(this).val(), ruleID, productBuyID));
        wgblResetData();
    });

    $(document).on('click', '.wgbl-product-buy-add-product', function () {
        let rule = $(this).closest('.wgbl-rule-item');
        let ruleID = rule.attr('data-id');
        let productBuyID = parseInt($(this).closest('.wgbl-rule-item').find('.wgbl-product-buy-items .wgbl-rule-item-sortable-item').length);
        rule.find('.wgbl-product-buy-items').append(wgblRuleProductsBuyNewItem(ruleID, productBuyID));
        wgblResetData();
        wgblSetSortableItems();
    });

    $(document).on('click', '.wgbl-product-item-delete', function () {
        let ruleItem = $(this).closest('.wgbl-rule-item');
        $(this).closest('.wgbl-rule-item-sortable-item').remove();
        wgblProductBuyFixPriority(ruleItem);
    });

    $(document).on('change', '.wgbl-product-buy-product-meta-field-type', function () {
        let ruleID = $(this).closest('.wgbl-rule-item').attr('data-id');
        let productBuyID = $(this).closest('.wgbl-rule-item-sortable-item').attr('data-id');
        $(this).closest('.wgbl-product-buy-extra-fields').find('.wgbl-product-buy-extra-fields-col-4').html(wgblGetProductBuyProductMetaFieldTypeFields($(this).val(), ruleID, productBuyID))
    });

    $(document).on('change', '.wgbl-product-buy-coupons-applied-type', function () {
        let ruleID = $(this).closest('.wgbl-rule-item').attr('data-id');
        let productBuyID = $(this).closest('.wgbl-rule-item-sortable-item').attr('data-id');
        $(this).closest('.wgbl-product-buy-extra-fields').find('.wgbl-product-buy-extra-fields-col-4').html(wgblGetProductBuyCouponsAppliedTypeFields($(this).val(), ruleID, productBuyID));
        wgblResetData();
    });
})

function wgblGetProductBuyProductMetaFieldTypeFields(type, ruleID, productBuyID) {
    let output;
    switch (type) {
        case 'contains':
        case 'does_not_contain':
        case 'does_not_contain':
        case 'begins_with':
        case 'ends_with':
        case 'equals':
        case 'does_not_equal':
        case 'less_than':
        case 'less_or_equal_to':
        case 'more_than':
        case 'more_or_equal':
            output = '<input type="text" name="rule[' + ruleID + '][product_buy][' + productBuyID + '][value]" placeholder="Value ..." required>';
            break;
        default:
            output = '';
    }
    return output;
}

function wgblGetProductBuyCouponsAppliedTypeFields(type, ruleID, productBuyID) {
    let output;
    switch (type) {
        case 'at_least_one':
        case 'all':
        case 'only':
        case 'none':
            output = '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][coupons][]" class="wgbl-select2-coupons" data-type="select2" data-placeholder="Select ..." multiple required></select>';
            break;
        default:
            output = '';
    }
    return output;
}

function wgblRuleProductsBuyNewItem(ruleID, productBuyID, type = '') {
    let output = '' +
        '<div class="wgbl-rule-item-sortable-item" data-id="' + productBuyID + '">' +
        '<button type="button" class="wgbl-rule-item-product-buy-sortable-btn wgbl-button-tr wgbl-float-left"><i class="dashicons dashicons-menu"></i></button>' +
        '<div class="wgbl-w20p">' +
        '<div class="wgbl-form-group">' +
        '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][type]" class="wgbl-rule-product-buy-product-item wgbl-select2-grouped" data-type="select2">' +
        '<optgroup label="Product">' +
        '<option value="product">Product</option>' +
        '<option value="product_variation">Product Variation</option>' +
        '<option value="product_category">Product Category</option>' +
        '<option value="product_attribute">Product Attributes</option>' +
        '<option value="product_tag">Product Tags</option>' +
        '</optgroup>' +
        '<optgroup label="Product Property">' +
        '<option value="product_regular_price">Product regular price</option>' +
        '<option value="product_is_on_sale">Product is on sale</option>' +
        '<option value="product_stock_quantity">Product stock quantity</option>' +
        '<option value="product_shipping_classes">Product shipping class</option>' +
        '<option value="product_meta_field">Product meta field</option>' +
        '</optgroup>' +
        '</select>' +
        '</div>' +
        '</div>' +
        '<div class="wgbl-product-buy-extra-fields">' +
        wgblSetProductBuyFields((type) ? type : 'product', ruleID, productBuyID) +
        '</div> ' +
        '<button type="button" class="wgbl-button-tr wgbl-float-right wgbl-product-item-delete"><i class="dashicons dashicons-no-alt"></i></button>' +
        '</div>' +
        '';
    return output;
}

function wgblShowProductBuy(id) {
    let productBuy = jQuery('.wgbl-rule-item[data-id=' + id + '] div[data-type=product-buy]');
    productBuy.find('select').prop('disabled', false);
    productBuy.find('input').prop('disabled', false);
    productBuy.show();
}

function wgblHideProductBuy(id) {
    let productBuy = jQuery('.wgbl-rule-item[data-id=' + id + '] div[data-type=product-buy]');
    productBuy.find('select').prop('disabled', true);
    productBuy.find('input').prop('disabled', true);
    productBuy.hide();
}

function wgblProductBuyProductField(type, ruleID, productBuyID) {
    let output = '' +
        '<div class="wgbl-w30p">' +
        '<div class="wgbl-form-group">' +
        '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]">' +
        '<option value="in_list">in list</option>' +
        '<option value="not_in_list">not in list</option>' +
        '</select>' +
        '</div>' +
        '</div>' +
        '<div class="wgbl-w70p">' +
        '<div class="wgbl-form-group">' +
        '<select class="wgbl-select2-' + type + '" name="rule[' + ruleID + '][product_buy][' + productBuyID + '][' + type + '][]" data-type="select2" data-placeholder="Select values ..." multiple required>' +
        '</select>' +
        '</div>' +
        '</div>' +
        '';
    return output;
}

function wgblSetProductBuyFields(value, ruleID, productBuyID) {
    let output = "";
    switch (value) {
        case 'product':
            output = wgblProductBuyProductField('products', ruleID, productBuyID);
            break;
        case 'product_variation':
            output = wgblProductBuyProductField('variations', ruleID, productBuyID);
            break;
        case 'product_category':
            output = wgblProductBuyProductField('categories', ruleID, productBuyID);
            break;
        case 'product_attribute':
            output = '' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]">' +
                '<option value="at_least_one">at least one of selected</option>' +
                '<option value="all">all of selected</option>' +
                '<option value="only">only selected</option>' +
                '<option value="none">none of selected</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w70p">' +
                '<div class="wgbl-form-group">' +
                '<select class="wgbl-select2-attributes" name="rule[' + ruleID + '][product_buy][' + productBuyID + '][attributes][]" data-type="select2" data-placeholder="Select values ..." multiple required>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '';
            break;
        case 'product_tag':
            output = '' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]">' +
                '<option value="at_least_one">at least one of selected</option>' +
                '<option value="all">all of selected</option>' +
                '<option value="only">only selected</option>' +
                '<option value="none">none of selected</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w70p">' +
                '<div class="wgbl-form-group">' +
                '<select class="wgbl-select2-tags" name="rule[' + ruleID + '][product_buy][' + productBuyID + '][tags][]" data-type="select2" data-placeholder="Select values ..." multiple required>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '';
            break;
        case 'product_regular_price':
            output = '' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]">' +
                '<option value="at_least">at least</option>' +
                '<option value="more_than">more than</option>' +
                '<option value="not_more_than">not more than</option>' +
                '<option value="less_than">less than</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w70p">' +
                '<div class="wgbl-form-group">' +
                '<input name="rule[' + ruleID + '][product_buy][' + productBuyID + '][value]" type="number" min="0" placeholder="0.00" required>' +
                '</div>' +
                '</div>' +
                '';
            break;
        case 'product_is_on_sale':
            output = '' +
                '<div class="wgbl-w70p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][value]" required>' +
                '<option value="yes">Yes</option>' +
                '<option value="no">No</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '';
            break;
        case 'product_stock_quantity':
            output = '' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]">' +
                '<option value="at_least">at least</option>' +
                '<option value="more_than">more than</option>' +
                '<option value="not_more_than">not more than</option>' +
                '<option value="less_than">less than</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w70p">' +
                '<div class="wgbl-form-group">' +
                '<input name="rule[' + ruleID + '][product_buy][' + productBuyID + '][value]" type="number" min="0" placeholder="0" required>' +
                '</div>' +
                '</div>' +
                '';
            break;
        case 'product_shipping_classes':
            output = wgblProductBuyProductField('shipping_classes', ruleID, productBuyID);
            break;
        case 'product_meta_field':
            output = '' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<input name="rule[' + ruleID + '][product_buy][' + productBuyID + '][product_meta_field]" type="text" placeholder="meta field key" required>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]" class="wgbl-product-buy-product-meta-field-type">' +
                '<option value="is_empty">is empty</option>' +
                '<option value="is_not_empty">is not empty</option>' +
                '<option value="contains">contains</option>' +
                '<option value="does_not_contain">does not contain</option>' +
                '<option value="begins_with">begins with</option>' +
                '<option value="ends_with">ends with</option>' +
                '<option value="equals">equals</option>' +
                '<option value="does_not_equal">does not equal</option>' +
                '<option value="less_than">less than</option>' +
                '<option value="less_or_equal_to">less or equal to</option>' +
                '<option value="more_than">more than</option>' +
                '<option value="more_or_equal">more or equal to</option>' +
                '<option value="is_checked">is checked</option>' +
                '<option value="is_not_checked">is not checked</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<div class="wgbl-product-buy-extra-fields-col-4"></div>' +
                '</div>' +
                '</div>' +
                '';
            break;
        case 'coupons_applied':
            output = '' +
                '<div class="wgbl-w30p">' +
                '<div class="wgbl-form-group">' +
                '<select name="rule[' + ruleID + '][product_buy][' + productBuyID + '][method_option]" class="wgbl-product-buy-coupons-applied-type">' +
                '<option value="at_least_one_any">at least one of any</option>' +
                '<option value="at_least_one">at least one of selected</option>' +
                '<option value="all">all of selected</option>' +
                '<option value="only">only selected</option>' +
                '<option value="none">none of selected</option>' +
                '<option value="none_at_all">none at all</option>' +
                '</select>' +
                '</div>' +
                '</div>' +
                '<div class="wgbl-w70p">' +
                '<div class="wgbl-form-group">' +
                '<div class="wgbl-product-buy-extra-fields-col-4"></div>' +
                '</div>' +
                '</div>' +
                '';
            break;
    }

    return output;
}