"use strict";

var optionValues = [];
var productsList = false;
var variationsList = false;
var categoriesList = false;
var attributesList = false;
var tagsList = false;
var taxonomiesList = false;
var shippingClassesList = false;
var customersList = false;
var userRolesList = false;
var userCapabilitiesList = false;

function wgblGetCustomers() {
    let query;
    jQuery(".wgbl-select2-customers").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_customers",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Customer Name ...",
        minimumInputLength: 1
    });
}

function wgblGetUserRoles() {
    let query;
    jQuery(".wgbl-select2-user-roles").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_user_roles",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Role Name ...",
        minimumInputLength: 1
    });
}

function wgblGetUserCapabilities() {
    let query;
    jQuery(".wgbl-select2-user-capabilities").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_user_capabilities",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Name ...",
        minimumInputLength: 1
    });
}

function wgblGetProducts() {
    let query;
    jQuery(".wgbl-select2-products").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_products",
                    search: params.term,
                };
                return query;
            },
        },
        placeholder: "Product Name ...",
        minimumInputLength: 1
    });
}

function wgblGetProductsVariations() {
    let query;
    jQuery(".wgbl-select2-products-variations").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_products_variations",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Product Name ...",
        minimumInputLength: 1
    });
}

function wgblGetVariations() {
    let query;
    jQuery(".wgbl-select2-variations").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_variations",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "variation Name ...",
        minimumInputLength: 1
    });
}

function wgblGetTags() {
    let query;
    jQuery(".wgbl-select2-tags").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_tags",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Tag Name ...",
        minimumInputLength: 1
    });
}

function wgblGetCategories() {
    let query;
    jQuery(".wgbl-select2-categories").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_categories",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Category Name ...",
        minimumInputLength: 1
    });
}

function wgblGetAttributes() {
    let query;
    jQuery(".wgbl-select2-attributes").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_attributes",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Attribute Name ...",
        minimumInputLength: 1
    });
}

function wgblGetTaxonomies() {
    let query;
    jQuery(".wgbl-select2-taxonomies").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_taxonomies",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Taxonomy Name ...",
        minimumInputLength: 1
    });
}

function wgblGetShippingClass() {
    let query;
    jQuery(".wgbl-select2-shipping_classes").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_shipping_class",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Product Name ...",
        minimumInputLength: 1
    });
}

function wgblGetCoupons() {
    let query;
    jQuery(".wgbl-select2-coupons").select2({
        ajax: {
            type: "post",
            delay: 200,
            url: WGBL_DATA.ajax_url,
            dataType: "json",
            data: function(params) {
                query = {
                    action: "wgbl_get_coupons",
                    search: params.term
                };
                return query;
            }
        },
        placeholder: "Coupon Name ...",
        minimumInputLength: 1
    });
}

function wgblResetData() {
    wgblGetCustomers();
    wgblGetUserRoles();
    wgblGetUserCapabilities();
    wgblGetProducts();
    wgblGetTaxonomies();
    wgblGetProductsVariations();
    wgblGetVariations();
    wgblGetTags();
    wgblGetCategories();
    wgblGetAttributes();
    wgblGetShippingClass();
    wgblGetCoupons();
    wgblSetSortableItems();
    wgblDatepickerSet();
    wgblSelect2Set();
    jQuery('select[data-type=select2]').css({ width: '100%' });
}

function wgblGetRules(rules) {
    jQuery.each(rules, function(i, rule) {
        wgblAddRule(i, rule, wgblSetRuleValues);
        if (i === (rules.length - 1)) {
            setTimeout(function() {
                wgblResetData();
            }, 500)
        }
    })
}

function wgblSetRuleValues(ruleElement, rule) {
    let id = ruleElement.attr('data-id');
    ruleElement.addClass('wgbl-rule-' + rule.status);
    if (rule.rule_name) {
        ruleElement.find('.wgbl-rule-title').html(rule.rule_name);
    }
    ruleElement.find('select[name="rule[' + id + '][status]"]').val(rule.status).change();
    ruleElement.find('select[name="rule[' + id + '][quantities_based_on]"]').val(rule.quantities_based_on).trigger('change');
    ruleElement.find('input[name="rule[' + id + '][rule_name]"]').val(rule.rule_name);
    ruleElement.find('input[name="rule[' + id + '][description]"]').val(rule.description);
    ruleElement.find('select[name="rule[' + id + '][quantity][subtotal_type]"]').val(rule.quantity.subtotal_type).change();
    ruleElement.find('input[name="rule[' + id + '][quantity][subtotal_amount]"]').val(rule.quantity.subtotal_amount);
    ruleElement.find('input[name="rule[' + id + '][quantity][buy]"]').val(rule.quantity.buy);
    ruleElement.find('input[name="rule[' + id + '][quantity][get]"]').val(rule.quantity.get);
    if (rule.quantity.same_gift == 'yes') {
        ruleElement.find('input[data-id="' + id + '"][data-name="same_gift"]').prop('checked', true);
        ruleElement.find('input[name="rule[' + id + '][quantity][same_gift]"]').val('yes');
    } else {
        ruleElement.find('input[data-id="' + id + '"][data-name="same_gift"]').prop('checked', false);
        ruleElement.find('input[name="rule[' + id + '][quantity][same_gift]"]').val('no');
    }

    if (rule.quantity.auto_add_gift_to_cart == 'yes') {
        ruleElement.find('input[data-id="' + id + '"][data-name="auto_add_gift_to_cart"]').prop('checked', true);
        ruleElement.find('input[name="rule[' + id + '][quantity][auto_add_gift_to_cart]"]').val('yes');
    } else {
        ruleElement.find('input[data-id="' + id + '"][data-name="auto_add_gift_to_cart"]').prop('checked', false);
        ruleElement.find('input[name="rule[' + id + '][quantity][auto_add_gift_to_cart]"]').val('no');
    }

    if (typeof rule.product_buy !== 'undefined') {
        jQuery.each(rule.product_buy, function(i, item) {
            ruleElement.find('.wgbl-product-buy-items').append(wgblRuleProductsBuyNewItem(id, i, item.type)).ready(function() {
                let buyItem = ruleElement.find('.wgbl-product-buy-items .wgbl-rule-item-sortable-item[data-id=' + i + ']');
                buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][type]"]').val(item.type);
                buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][method_option]"]').val(item.method_option).change();
                buyItem.find('input[name="rule[' + id + '][product_buy][' + i + '][product_meta_field]"]').val(item.product_meta_field);
                buyItem.find('[name="rule[' + id + '][product_buy][' + i + '][value]"]').val(item.value);
                if (item.products) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][products][]"]'), 'products', item.products);
                }
                if (item.variations) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][variations][]"]'), 'variations', item.variations);
                }
                if (item.categories) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][categories][]"]'), 'categories', item.categories);
                }
                if (item.attributes) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][attributes][]"]'), 'attributes', item.attributes);
                }
                if (item.tags) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][tags][]"]'), 'tags', item.tags);
                }
                if (item.coupons) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][coupons][]"]'), 'coupons', item.coupons);
                }
                if (item.shipping_classes) {
                    wgblSetSelectedOption(buyItem.find('select[name="rule[' + id + '][product_buy][' + i + '][shipping_classes][]"]'), 'shipping_classes', item.shipping_classes);
                }
            });
        });
    }

    if (typeof rule.include_products !== 'undefined') {
        wgblSetSelectedOption(ruleElement.find('select[name="rule[' + id + '][include_products][]"]'), 'products', rule.include_products);
    }

    if (typeof rule.exclude_products !== 'undefined') {
        wgblSetSelectedOption(ruleElement.find('select[name="rule[' + id + '][exclude_products][]"]'), 'products', rule.exclude_products);
    }

    if (typeof rule.include_taxonomy !== 'undefined') {
        wgblSetSelectedOption(ruleElement.find('select[name="rule[' + id + '][include_taxonomy][]"]'), 'taxonomies', rule.include_taxonomy);
    }

    if (typeof rule.exclude_taxonomy !== 'undefined') {
        wgblSetSelectedOption(ruleElement.find('select[name="rule[' + id + '][exclude_taxonomy][]"]'), 'taxonomies', rule.exclude_taxonomy);
    }

    if (typeof rule.condition !== 'undefined') {
        jQuery.each(rule.condition, function(i, item) {
            ruleElement.find('.wgbl-condition-items').append(wgblRuleConditionsNewItem(id, i, item.type)).ready(function() {
                let conditionItem = ruleElement.find('.wgbl-condition-items .wgbl-rule-item-sortable-item[data-id=' + i + ']');
                conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][type]"]').val(item.type);
                conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][method_option]"]').val(item.method_option).change();
                conditionItem.find('input[name="rule[' + id + '][condition][' + i + '][meta_field_key]"]').val(item.meta_field_key);
                conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][time]"]').val(item.time);
                conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][value][]"]').val(item.value);
                conditionItem.find('[name="rule[' + id + '][condition][' + i + '][value]"]').val(item.value);

                if (item.products) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][products][]"]'), 'products', item.products);
                }
                if (item.variations) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][variations][]"]'), 'variations', item.variations);
                }
                if (item.categories) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][categories][]"]'), 'categories', item.categories);
                }
                if (item.attributes) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][attributes][]"]'), 'attributes', item.attributes);
                }
                if (item.tags) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][tags][]"]'), 'tags', item.tags);
                }
                if (item.shipping_classes) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][shipping_classes][]"]'), 'shipping_classes', item.shipping_classes);
                }
                if (item.customers) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][customers][]"]'), 'customers', item.customers);
                }
                if (item.user_roles) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][user_roles][]"]'), 'user_roles', item.user_roles);
                }
                if (item.user_capabilities) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][user_capabilities][]"]'), 'user_capabilities', item.user_capabilities);
                }
                if (item.coupons) {
                    wgblSetSelectedOption(conditionItem.find('select[name="rule[' + id + '][condition][' + i + '][coupons][]"]'), 'coupons', item.coupons);
                }
            });
        });
    }

    setTimeout(function() {
        wgblResetData();
    }, 500)
}

function wgblSetOptionValues(values) {
    optionValues = values;
}

function wgblSetSelectedOption(element, type, ids) {
    jQuery.each(ids, function(num, id) {
        if (optionValues[type]) {
            let data = {
                id: id,
                text: optionValues[type][id]
            };
            let newOption = new Option(data.text, data.id, true, true);
            element.append(newOption);
        }
    });
}

function uidGenerator() {
    return jQuery.now() + Math.floor((Math.random() * 999) + 100);
}

function wgblAddRule(id, rule = [], callback = '') {
    let uid = (rule.uid) ? rule.uid : uidGenerator();
    let ruleMethodOptions = (WGBL_DATA.ruleMethodOptions) ? WGBL_DATA.ruleMethodOptions : '';

    let newRule = '' +
        '<div class="wgbl-rule-item" data-id="' + id + '">' +
        '<input type="hidden" name="rule[' + id + '][uid]" value="' + uid + '">' +
        '<div class="wgbl-rule-header">' +
        '<div class="wgbl-float-left">' +
        '<button type="button" class="wgbl-rule-sortable-btn wgbl-button-tr" data-id="sort"><i class="dashicons dashicons-menu"></i></button>' +
        '<h3 class="wgbl-rule-title">Gift Rule</h3>' +
        '<h4 class="wgbl-rule-method-name">Simple</h4>' +
        '<h4 class="wgbl-rule-method-id">ID: ' + uid + ' </h4>' +
        '</div>' +
        '<div class="wgbl-float-right">' +
        '<select name="rule[' + id + '][status]" class="wgbl-mr5 wgbl-rule-item-status">' +
        '<option value="enable">Enable</option>' +
        '<option value="disable">Disable</option>' +
        '</select>' +
        '<button type="button" class="wgbl-rule-duplicate wgbl-button-tr" data-id="duplicate"><i class="dashicons dashicons-admin-page"></i></button>' +
        '<button type="button" class="wgbl-rule-delete wgbl-button-tr" data-id="delete"><i class="dashicons dashicons-no-alt"></i></button>' +
        '</div>' +
        '</div>' +
        '<div class="wgbl-rule-body">' +
        '<div class="wgbl-col-6">' +
        '<div class="wgbl-form-group">' +
        '<label>Method</label>' +
        '<select name="rule[' + id + '][method]" class="wgbl-rule-method">' +
        ruleMethodOptions +
        '</select>' +
        '</div>' +
        '</div>' +
        '<div class="method-dependencies">' +

        '<div class="wgbl-col-3" data-type="quantities-based-on">' +
        '<div class="wgbl-form-group">' +
        '<label>Quantities Based On</label>' +
        '<select name="rule[' + id + '][quantities_based_on]" class="wgbl-quantities-based-on">' +
        '<optgroup label="Individual Products">' +
        '<option value="each_individual_product">Each individual product</option>' +
        '<option value="each_individual_variation">Each individual variation - Pro version</option>' +
        '<option value="each_individual_cart_line_item">Each individual cart line item - Pro version</option>' +
        '</optgroup>' +
        '<optgroup label="All Matched Products">' +
        '<option value="quantities_added_up_by_category">Quantities added up by category - Pro version</option>' +
        '<option value="all_quantities_added_up">All quantities added up - Pro version</option>' +
        '</optgroup>' +
        '</select>' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-3" data-type="rule_name">' +
        '<div class="wgbl-form-group">' +
        '<label>Rule name</label>' +
        '<input type="text" name="rule[' + id + '][rule_name]" placeholder="Rule name ..." class="wgbl-rule-name" required>' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-12" data-type="description">' +
        '<div class="wgbl-form-group">' +
        '<label>Description</label>' +
        '<input type="text" name="rule[' + id + '][description]" placeholder="Description ...">' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-12" data-type="quantities">' +
        '<div class="wgbl-rule-section">' +
        '<h3>Quantities & Settings</h3>' +
        '<div class="wgbl-rule-section-content">' +

        '<div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-subtotal-amount">' +
        '<div class="wgbl-form-group">' +
        '<label>Subtotal Amount</label>' +
        '<input type="number" min="0" name="rule[' + id + '][quantity][subtotal_amount]">' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-buy">' +
        '<div class="wgbl-form-group">' +
        '<label>Buy</label>' +
        '<input name="rule[' + id + '][quantity][buy]" type="number" min="1" placeholder="Quantity" required>' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-get">' +
        '<div class="wgbl-form-group">' +
        '<label>Get</label>' +
        '<input name="rule[' + id + '][quantity][get]" type="number" min="1" placeholder="Quantity" required>' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-same-gift">' +
        '<div class="wgbl-form-group wgbl-checkbox-group">' +
        '<label><input type="checkbox" data-id="' + id + '" data-name="same_gift" class="wgbl-rule-quantities-checkbox"> Same Gift</label>' +
        '<input type="hidden" name="rule[' + id + '][quantity][same_gift]" value="no">' +
        '</div>' +
        '</div>' +

        '<div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-auto-add-gift-to-cart">' +
        '<div class="wgbl-form-group wgbl-checkbox-group">' +
        '<label><input type="checkbox" data-id="' + id + '" data-name="auto_add_gift_to_cart" class="wgbl-rule-quantities-checkbox"> Auto Add Gift - Pro Version</label>' +
        '<input type="hidden" name="rule[' + id + '][quantity][auto_add_gift_to_cart]" value="no">' +
        '</div>' +
        '</div>' +

        '</div>' +
        '</div>' +
        '</div>' +


        '<div class="wgbl-col-12" data-type="product-buy">' +
        '<div class="wgbl-rule-section">' +
        '<h3>Products - Buy</h3>' +
        '<div class="wgbl-rule-section-content">' +
        '<div class="wgbl-product-buy-items">' +
        '</div>' +
        '<button type="button" class="wgbl-float-right wgbl-button wgbl-button-blue wgbl-product-buy-add-product">Add Product</button>' +
        '</div>' +
        '</div>' +
        '</div>' +


        '<div class="wgbl-col-12" data-type="get">' +
        '<div class="wgbl-rule-section">' +
        '<h3>Get</h3>' +
        '<div class="wgbl-rule-section-content">' +
        '<div class="wgbl-col-6">' +
        '<div class="wgbl-form-group">' +
        '<label>Include Products</label>' +
        '<select name="rule[' + id + '][include_products][]" class="wgbl-select2-products-variations" data-type="select2" multiple data-placeholder="Select ...">' +
        '</select>' +
        '</div>' +
        '</div>' +
        '<div class="wgbl-col-6">' +
        '<div class="wgbl-form-group">' +
        '<label>Exclude Products</label>' +
        '<select name="rule[' + id + '][exclude_products][]" class="wgbl-select2-products-variations" data-type="select2" multiple data-placeholder="Select ...">' +
        '</select>' +
        '</div>' +
        '</div>' +
        '<div class="wgbl-col-6">' +
        '<div class="wgbl-form-group">' +
        '<label>Include Category/Tag/Taxonomy</label>' +
        '<select name="rule[' + id + '][include_taxonomy][]" class="wgbl-select2-taxonomies" multiple data-type="select2" data-placeholder="Select ...">' +
        '</select>' +
        '</div>' +
        '</div>' +
        '<div class="wgbl-col-6">' +
        '<div class="wgbl-form-group">' +
        '<label>Exclude Category/Tag/Taxonomy</label>' +
        '<select name="rule[' + id + '][exclude_taxonomy][]" class="wgbl-select2-taxonomies" data-type="select2" multiple data-type="select2" data-placeholder="Select ...">' +
        '</select>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>' +


        '<div class="wgbl-col-12" data-type="conditions">' +
        '<div class="wgbl-rule-section">' +
        '<h3>Conditions</h3>' +
        '<div class="wgbl-rule-section-content">' +
        '<div class="wgbl-condition-items">' +
        '</div>' +
        '<button type="button" class="wgbl-float-right wgbl-button wgbl-button-blue wgbl-add-condition">Add Condition</button>' +
        '</div>' +
        '</div>' +
        '</div>' +


        '</div>' +
        '</div>' +
        '</div>' +
        '';

    jQuery('#wgbl-rules').append(newRule).ready(function() {
        let item = jQuery('#wgbl-rules .wgbl-rule-item[data-id=' + id + ']');
        item.find('.wgbl-rule-method').val((rule.method) ? rule.method : 'simple').trigger('change');
        if (!rule.method) {
            item.find('.wgbl-rule-body').slideDown();
            if (!callback) {
                wgblResetData();
            }
        }
        if (callback) {
            callback(item, rule)
        }
    });
}

function wgblSetTipsyTooltip() {
    jQuery('[title]').tipsy({
        html: true,
        arrowWidth: 10, //arrow css border-width * 2, default is 5 * 2
        attr: 'data-tipsy',
        cls: null,
        duration: 150,
        offset: 7,
        position: 'top-center',
        trigger: 'hover',
        onShow: null,
        onHide: null
    });
}

function wgblSelect2Set() {
    if (jQuery.fn.select2) {
        jQuery('.wgbl-select2').select2();
        jQuery('.wgbl-select2-grouped').select2();
    }
}

function wgblDatepickerSet() {
    if (jQuery.fn.datetimepicker) {
        jQuery('.wgbl-datepicker').datetimepicker({
            timepicker: false,
            format: 'Y-m-d'
        });

        jQuery('.wgbl-timepicker').datetimepicker({
            datepicker: false,
            format: 'H:i'
        });

        jQuery('.wgbl-datetimepicker').datetimepicker({
            format: 'Y-m-d H:i'
        });
    }
}

function wgblSetSortableItems() {
    if (jQuery.fn.sortable) {
        if (jQuery(".wgbl-product-buy-items")) {
            let wgblProductGet = jQuery(".wgbl-product-buy-items");
            wgblProductGet.sortable({
                handle: ".wgbl-rule-item-product-buy-sortable-btn",
                cancel: "",
                stop: function(event, ui) {
                    wgblProductBuyFixPriority(ui.item.closest('.wgbl-rule-item'))
                }
            });
            wgblProductGet.disableSelection();
        }

        if (jQuery(".wgbl-condition-items")) {
            let wgblConditions = jQuery(".wgbl-condition-items");
            wgblConditions.sortable({
                handle: ".wgbl-rule-item-condition-sortable-btn",
                cancel: "",
                stop: function(event, ui) {
                    wgblConditionsFixPriority(ui.item.closest('.wgbl-rule-item'))
                }
            });
            wgblConditions.disableSelection();
        }

        if (jQuery("#wgbl-rules")) {
            let wgblRules = jQuery("#wgbl-rules");
            wgblRules.sortable({
                handle: ".wgbl-rule-sortable-btn",
                cancel: "",
                stop: function(event, ui) {
                    wgblRulesFixPriority()
                }
            });
            wgblRules.disableSelection();
        }
    }
}

function wgblRulesFixPriority() {
    let id;
    jQuery('.wgbl-rule-item').each(function(i) {
        id = i;
        jQuery(this).attr('data-id', id);
        jQuery(this).find('select, input').each(function(i) {
            if (typeof jQuery(this).prop('name') !== 'undefined') {
                let newName = jQuery(this).prop('name').replace(new RegExp('rule\\[(\\{i\\}|\\d+)\\]?'), 'rule[' + id + ']');
                jQuery(this).prop('name', newName);
            }
        });
    });
}

function wgblConditionsFixPriority(ruleItem) {
    let id;
    ruleItem.find('.wgbl-condition-items .wgbl-rule-item-sortable-item').each(function(i) {
        id = i;
        jQuery(this).find('select, input').each(function(i) {
            if (typeof jQuery(this).prop('name') !== 'undefined') {
                let newName = jQuery(this).prop('name').replace(new RegExp('\\[condition\\]\\[(\\{i\\}|\\d+)\\]?'), '[condition][' + id + ']');
                jQuery(this).prop('name', newName);
            }
        });
    });
}

function wgblProductBuyFixPriority(ruleItem) {
    let id;
    ruleItem.find('.wgbl-product-buy-items .wgbl-rule-item-sortable-item').each(function(i) {
        id = i;
        jQuery(this).find('select, input').each(function(i) {
            if (typeof jQuery(this).prop('name') !== 'undefined') {
                let newName = jQuery(this).prop('name').replace(new RegExp('\\[product_buy\\]\\[(\\{i\\}|\\d+)\\]?'), '[product_buy][' + id + ']');
                jQuery(this).prop('name', newName);
            }
        });
    });
}

function wgblRuleDuplicate(ruleItem) {
    jQuery('#wgbl-rules .wgbl-rule-body').slideUp(250);

    ruleItem.clone().appendTo('#wgbl-rules').ready(function() {
        let duplicated = jQuery('#wgbl-rules .wgbl-rule-item').last();
        duplicated.attr('data-id', parseInt(jQuery('.wgbl-rule-item').length) - 1);
        wgblRulesFixPriority();
        let sID = ruleItem.attr('data-id');
        let dID = duplicated.attr('data-id');
        duplicated.find('.wgbl-rule-body').slideDown(250).css({
            height: 'auto'
        });

        let newUid = uidGenerator();

        duplicated.find('.wgbl-rule-method').val(ruleItem.find('.wgbl-rule-method').val()).change();
        duplicated.find('.wgbl-rule-item-status').val(ruleItem.find('.wgbl-rule-item-status').val()).change();
        duplicated.find('input[name="rule[' + dID + '][uid]"]').val(newUid).change();
        duplicated.find('.wgbl-rule-method-id').text('ID: ' + newUid);
        duplicated.find('select[name="rule[' + dID + '][quantities_based_on]"]').val(ruleItem.find('select[name="rule[' + sID + '][quantities_based_on]"]').val()).change();

        if (ruleItem.find('.wgbl-product-buy-items .wgbl-rule-item-sortable-item').length > 0) {
            jQuery.each(ruleItem.find('.wgbl-product-buy-items .wgbl-rule-item-sortable-item'), function(i, item) {
                wgblDuplicateProductBuyItemFields(sID, dID, i);
            });
        }

        wgblDuplicateGetSectionItems(sID, dID);

        if (ruleItem.find('.wgbl-condition-items .wgbl-rule-item-sortable-item').length > 0) {
            jQuery.each(ruleItem.find('.wgbl-condition-items .wgbl-rule-item-sortable-item'), function(i, item) {
                let itemType = duplicated.find('select[name="rule[' + dID + '][condition][' + i + '][type]"]');
                itemType.closest('.wgbl-form-group').find('.select2-container').remove();
                itemType.val(ruleItem.find('select[name="rule[' + sID + '][condition][' + i + '][type]"]').val());
                wgblDuplicateConditionItemFields(sID, dID, i);
            });
        }

        setTimeout(function() {
            wgblResetData();
        }, 500)
    });
}

function wgblDuplicateProductBuyItemFields(sourceId, destinationId, iteration) {
    let itemType = jQuery('select[name="rule[' + destinationId + '][product_buy][' + iteration + '][type]"]');
    itemType.closest('.wgbl-form-group').find('.select2-container').remove();
    itemType.val(jQuery('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][type]"]').val());
    jQuery('select[name="rule[' + destinationId + '][product_buy][' + iteration + '][method_option]"]').val(jQuery('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][method_option]"]').val());
    jQuery('input[name="rule[' + destinationId + '][product_buy][' + iteration + '][product_meta_field]"]').val(jQuery('input[name="rule[' + sourceId + '][product_buy][' + iteration + '][product_meta_field]"]').val());
    jQuery('input[name="rule[' + destinationId + '][product_buy][' + iteration + '][value]"]').val(jQuery('input[name="rule[' + sourceId + '][product_buy][' + iteration + '][value]"]').val());
    jQuery('select[name="rule[' + destinationId + '][product_buy][' + iteration + '][value][]"]').val(jQuery('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][value][]"]').val());

    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][products][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][products][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][variations][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][variations][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][categories][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][categories][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][attributes][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][attributes][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][tags][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][tags][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][coupons][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][coupons][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][product_buy][' + iteration + '][shipping_classes][]"]', 'select[name="rule[' + destinationId + '][product_buy][' + iteration + '][shipping_classes][]"]');
}

function wgblDuplicateGetSectionItems(sourceId, destinationId) {
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][include_products][]"]', 'select[name="rule[' + destinationId + '][include_products][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][exclude_products][]"]', 'select[name="rule[' + destinationId + '][exclude_products][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][include_taxonomy][]"]', 'select[name="rule[' + destinationId + '][include_taxonomy][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][exclude_taxonomy][]"]', 'select[name="rule[' + destinationId + '][exclude_taxonomy][]"]');
}

function wgblDuplicateConditionItemFields(sourceId, destinationId, iteration) {
    jQuery('select[name="rule[' + destinationId + '][condition][' + iteration + '][method_option]"]').val(jQuery('select[name="rule[' + sourceId + '][condition][' + iteration + '][method_option]"]').val()).trigger('change');
    jQuery('input[name="rule[' + destinationId + '][condition][' + iteration + '][value]"]').val(jQuery('input[name="rule[' + sourceId + '][condition][' + iteration + '][value]"]').val()).trigger('change');
    jQuery('input[name="rule[' + destinationId + '][condition][' + iteration + '][meta_field_key]"]').val(jQuery('input[name="rule[' + sourceId + '][condition][' + iteration + '][meta_field_key]"]').val()).trigger('change');
    jQuery('select[name="rule[' + destinationId + '][condition][' + iteration + '][time]"]').val(jQuery('select[name="rule[' + sourceId + '][condition][' + iteration + '][time]"]').val()).trigger('change');
    jQuery('select[name="rule[' + destinationId + '][condition][' + iteration + '][value][]"]').val(jQuery('select[name="rule[' + sourceId + '][condition][' + iteration + '][value][]"]').val()).trigger('change');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][products][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][products][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][variations][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][variations][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][categories][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][categories][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][attributes][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][attributes][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][tags][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][tags][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][shipping_classes][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][shipping_classes][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][customers][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][customers][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][user_roles][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][user_roles][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][user_capabilities][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][user_capabilities][]"]');
    wgblDuplicateMultipleSelect2Item('select[name="rule[' + sourceId + '][condition][' + iteration + '][coupons][]"]', 'select[name="rule[' + destinationId + '][condition][' + iteration + '][coupons][]"]');
}

function wgblDuplicateMultipleSelect2Item(sourceRuleName, destinationRuleName) {
    jQuery(destinationRuleName).closest('.wgbl-form-group').find('.select2-container').remove();
    if (jQuery(sourceRuleName).val() && jQuery(destinationRuleName).find('option:selected').length < 1) {
        jQuery(sourceRuleName).find('option:selected').each(function() {
            jQuery(destinationRuleName).append("<option value='" + jQuery(this).attr('value') + "' selected='selected'>" + jQuery(this).text() + "</option>")
        });
    }
}

function wgblShowQuantitiesBasedOn(id) {
    let quantitiesBasedOn = jQuery('.wgbl-rule-item[data-id=' + id + ']').find('div[data-type=quantities-based-on]');
    quantitiesBasedOn.find('select').prop('disabled', false);
    quantitiesBasedOn.show();
}

function wgblHideQuantitiesBasedOn(id) {
    let quantitiesBasedOn = jQuery('.wgbl-rule-item[data-id=' + id + ']').find('div[data-type=quantities-based-on]');
    quantitiesBasedOn.find('select').prop('disabled', true);
    quantitiesBasedOn.hide();
}

function wgblSettingsDependenciesController(type) {
    let allDependencies = jQuery('#wgbl-settings-view-gift-in-cart-dependencies');
    // hide all dependencies
    allDependencies.find('.wgbl-settings-dependency-item').hide();

    if (type) {
        let dependencies = allDependencies.find('div[data-type="' + type + '"]');
        // show selected dependencies
        dependencies.show();
    }
}