<?php
function itg_check_quantity_gift_in_session($session_content, $get_cart_item_quantities_gift_stock = '')
{
    $count_gift         = 0;
    $count_rule_gift    = array();
    $count_rule_product = array();
    $gifts_set          = [];

    if (is_array($session_content) && count($session_content) > 0) {
        foreach ($session_content as $index => $set) {
            $count_gift  += $set['q'];
            $gifts_set[] = $set['id'];
            if (array_key_exists($set['uid'], $count_rule_gift)) {
                $count_rule_gift[$set['uid']]['q'] += $set['q'];
            } else {
                $count_rule_gift[$set['uid']]['q'] = $set['q'];
            }

            if (array_key_exists($index, $count_rule_product)) {
                $count_rule_product[$index]['q'] += $set['q'];
            } else {
                $count_rule_product[$index]['q'] = $set['q'];
            }
        }
    }

    $count_info = [
        'count_gift'         => $count_gift,
        'count_rule_gift'    => $count_rule_gift,
        'count_rule_product' => $count_rule_product,
        'gifts_set'          => $gifts_set,
    ];

    return $count_info;
}

function itg_get_cart_item_quantities_gift_stock()
{
    $quantities                 = array();
    $retrieved_group_input_value = WC()->session->get('gift_group_order_data');

    if (is_array($retrieved_group_input_value) && count($retrieved_group_input_value) > 0) {

        foreach ($retrieved_group_input_value as $index => $set) {
            if (isset($set['id_product'])) {
                $quantities[$set['id_product']] = isset($quantities[$set['id_product']]) ? $quantities[$set['id_product']] + $set['q'] : $set['q'];
            }
        }
    }

    return $quantities;
}


function itg_get_cart_item_stock_quantities($item_cart)
{
    $quantities = array();
    foreach ($item_cart as $cart_item_key => $values) {
        $product = $values['data'];
        $quantities[$product->get_stock_managed_by_id()] = isset($quantities[$product->get_stock_managed_by_id()]) ? $quantities[$product->get_stock_managed_by_id()] + $values['quantity'] : $values['quantity'];
    }

    return $quantities;
}

function itg_quantities_gift_stock($product, $product_qty_in_cart, $gift_id, $product_type, $settings, $item_hover)
{
    $text_stock_qty = '';
    if ($settings['show_stock_quantity'] != 'no') {
        $text_stock_qty = 'in stock';
    }
    $stock_status = 'in_stock';
    $get_stock_quantity = $product->get_stock_quantity();
    if (!$product->is_in_stock() && $get_stock_quantity <= 0) {
        $item_hover     = 'disable-hover';
        $text_stock_qty = 'out of stock';
        $stock_status = 'out_of_stock';
    } else if ($product->is_in_stock() && $get_stock_quantity >= 1) {
        $x = 0;
        $get_cart_item_quantities_gift_stock = itg_get_cart_item_quantities_gift_stock();
        $required_stock_in_cart_gift = isset($get_cart_item_quantities_gift_stock[$gift_id]) ? $get_cart_item_quantities_gift_stock[$gift_id] : 0;
        $required_stock_in_cart = isset($product_qty_in_cart[$product->get_stock_managed_by_id()]) ? $product_qty_in_cart[$product->get_stock_managed_by_id()] : 0;
        $x = $get_stock_quantity - ($required_stock_in_cart + $required_stock_in_cart_gift);

        if ($x <= 0) {
            $item_hover = 'disable-hover';
            $text_stock_qty = 'out of stock';
            $stock_status = 'out_of_stock';
        } else if ($product_type != 'variable' && $settings['show_stock_quantity'] == 'true') {
            $text_stock_qty = $x . ' ' . __('in stock', WGBL_NAME);
        } elseif ($product_type == 'variable' && $settings['show_stock_quantity'] == 'true') {
            $text_stock_qty = sprintf('%s', $x) . ' ' . __('in stock', WGBL_NAME);
        } else {
            $text_stock_qty = '';
        }
    }

    return [
        'item_hover'     => $item_hover,
        'text_stock_qty' => $text_stock_qty,
        'stock_status' => $stock_status,
    ];
}

function itg_get_settings()
{

    $settings = wgbl\classes\repositories\Setting::get_instance();
    $settings = $settings->get();

    $settings['position']                             = isset($settings['position']) ? $settings['position'] : 'bottom_cart';
    $settings['show_stock_quantity']                  = isset($settings['show_stock_quantity']) ? 'true' : 'no';
    $settings['layout']                               = isset($settings['layout']) ? $settings['layout'] : 'grid';
    $settings['child']                                = isset($settings['child']) ? 'true' : 'false';
    $settings['view_gift_in_cart']['number_per_page'] = isset($settings['view_gift_in_cart']['number_per_page']) ? $settings['view_gift_in_cart']['number_per_page'] : '4';;
    $settings['view_gift_in_cart']['desktop_columns'] = isset($settings['view_gift_in_cart']['desktop_columns']) ? $settings['view_gift_in_cart']['desktop_columns'] : 'wgb-col-md-2';;
    $settings['view_gift_in_cart']['tablet_columns'] = isset($settings['view_gift_in_cart']['tablet_columns']) ? $settings['view_gift_in_cart']['tablet_columns'] : 'wgb-col-sm-2';;
    $settings['view_gift_in_cart']['mobile_columns'] = isset($settings['view_gift_in_cart']['mobile_columns']) ? $settings['view_gift_in_cart']['mobile_columns'] : 'wgb-col-2';;
    $settings['view_gift_in_cart']['carousel']['loop'] = isset($settings['view_gift_in_cart']['carousel']['loop']) ? 'true' : 'false';;
    $settings['view_gift_in_cart']['carousel']['dots'] = isset($settings['view_gift_in_cart']['carousel']['dots']) ? 'true' : 'false';;
    $settings['view_gift_in_cart']['carousel']['nav'] = isset($settings['view_gift_in_cart']['carousel']['nav']) ? 'true' : 'false';;
    $settings['view_gift_in_cart']['carousel']['speed'] = isset($settings['view_gift_in_cart']['carousel']['speed']) ? $settings['view_gift_in_cart']['carousel']['speed'] : '5000';
    $settings['view_gift_in_cart']['carousel']['desktop'] = isset($settings['view_gift_in_cart']['carousel']['desktop']) ? $settings['view_gift_in_cart']['carousel']['desktop'] : '6';;
    $settings['view_gift_in_cart']['carousel']['tablet'] = isset($settings['view_gift_in_cart']['carousel']['tablet']) ? $settings['view_gift_in_cart']['carousel']['tablet'] : '2';;
    $settings['view_gift_in_cart']['carousel']['mobile'] = isset($settings['view_gift_in_cart']['carousel']['mobile']) ? $settings['view_gift_in_cart']['carousel']['mobile'] : '1';
    $settings['display_price'] = isset($settings['display_price']) ? $settings['display_price'] : 'no';

    return $settings;
}

if (!function_exists('itg_render_product_image')) {
    function itg_render_product_image($product, $echo = true)
    {

        if ($echo) {
            echo wp_kses_post($product->get_image());
        }

        return $product->get_image();
    }
}
