<?php

/**
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}

wp_enqueue_style('it-gift-style');
wp_enqueue_script('pw-gift-add-jquery-adv');


wp_enqueue_style('it-gift-owl-carousel-style');
wp_enqueue_script('it-gift-owl-carousel-jquery');


//wp_enqueue_script( 'it-gift-grid-jquery' );
//wp_enqueue_script( "jquery" );

$product_item = $text_stock_qty = '';

$retrieved_group_input_value = WC()->session->get('gift_group_order_data');
$count_info                 = itg_check_quantity_gift_in_session(WC()->session->get('gift_group_order_data'), itg_get_cart_item_quantities_gift_stock());

$add_gift = get_option('itg_localization_add_gift', 'Add Gift');
$our_gift = get_option('itg_localization_our_gift', 'Our Gift');
$select_gift = get_option('itg_localization_select_gift', 'Select Gift');

foreach ($this->show_gift_item_for_cart as $gift_item_key => $gift) {
    if (isset($gift['auto']) && $gift['auto'] == 'yes') {
        continue;
    }

    $item_hover = 'hovering';
    $disable    = false;

    $flag_count = false;
    if (in_array($gift['method'], array(
        'buy_x_get_x_repeat',
    ), true) && $gift['base_q'] == 'ind') {
        if (array_key_exists($gift_item_key, $retrieved_group_input_value) && $retrieved_group_input_value[$gift_item_key]['q'] >= $this->gift_item_variable['all_gifts'][$gift_item_key]['q']) {
            $flag_count = true;
        }
    } elseif (array_key_exists($gift['uid'], $count_info['count_rule_gift']) && $count_info['count_rule_gift'][$gift['uid']]['q'] >= $gift['pw_number_gift_allowed']) {
        $flag_count = true;
    }

    if ($flag_count) {
        //if ( $gift['disable_if'] == 'hide' ) {
        //			continue;
        //} else {
        $item_hover = 'disable-hover';
        //}
    } elseif (in_array($gift['key'], $count_info['gifts_set']) && $gift['can_several_gift'] == 'no') {
        if ($gift['disable_if'] == 'hide') {
            continue;
        } else {
            $item_hover = 'disable-hover';
        }
    }

    $img_html = $title_html = '';
    $product  = wc_get_product($gift['item']);
    $title    = $product->get_title();
    if ($product->post_type == 'product_variation') {
        $title = $product->get_name();
    }
    $product_type = $product->get_type();


    /**  Check Quantity  **/
    $x              = '';
    $flag_stock     = 0;
    $text_stock_qty = '';

    $array_return   = itg_quantities_gift_stock($product, $this->product_qty_in_cart, $gift['item'], $product_type, $this->settings, $item_hover);
    $item_hover     = $array_return['item_hover'];
    $text_stock_qty = $array_return['text_stock_qty'];
    $stock_status = $array_return['stock_status'];

    $product_item .= '
        <div class="wgb-product-item-cnt ' . esc_attr($item_hover) . ' ' . esc_attr($stock_status) . '">
            <div class="wgb-item-thumb">
                ' . itg_render_product_image($product, false) . '
                <div class="wgb-item-overlay"></div>
                <div class="wgb-stock"><div class="gift-product-stock">' . sprintf("%s", $text_stock_qty) . '</div></div>
            </div>
            <div class="wgb-item-content">
                <h1 class="wgb-item-title font-weight-bold">
                    <a href="#">' . sprintf("%s", $title) . '</a>
                </h1>';
    if ($product_type == 'variable') {
        $gift_key = ($item_hover != 'disable-hover') ? $gift['item'] : '';
        $product_item .= '
                                        <div class="wgb-add-gift-btn btn-select-gift-button" data-rule-id="' . esc_attr($gift['uid']) . '" data-id="' . esc_attr($gift_key) . '">
                                            <div class="wgb-loading-icon wgb-d-none">
                                                <div class="wgb-spinner wgb-spinner--2"></div>
                                            </div>
                                            <span>' . $select_gift . '</span>
                                        </div>';
    } else {
        $gift_key = ($item_hover != 'disable-hover') ? $gift['key'] : '';
        $product_item .= '
                                        <div class="wgb-add-gift-btn btn-add-gift-button" data-id="' . esc_attr($gift_key) . '">
                                            <div class="wgb-loading-icon wgb-d-none">
                                                <div class="wgb-spinner wgb-spinner--2"></div>
                                            </div>
                                            <span>' . $add_gift . '</span>
                                        </div>';
    }

    $product_item .= '
            </div>
        </div>';
}

if ($product_item == '') {
    return;
}
?>

<div class="adv-gift-section wgb-product-cnt wgb-frontend-gifts wgb-item-layout2">
    <div class="wgb-header-cnt">
        <h2 class="wgb-title text-capitalize font-weight-bold"><?php echo wp_kses_post($our_gift); ?></h2>
    </div>
    <div class="wgb-owl-carousel owl-carousel it-owl-carousel-items" id="pw_slider_adv_gift">
        <?php echo wp_kses_post($product_item); ?>
    </div>
</div>