<?php

/**
 * Exit if accessed directly
 */
if (!defined('ABSPATH')) {
    exit;
}

wp_enqueue_style('it-gift-datatables-style');
wp_enqueue_script('it-gift-datatables-js');


wp_enqueue_style('it-gift-style');
wp_enqueue_script('pw-gift-add-jquery-adv');

$product_item = $text_stock_qty = '';

$retrieved_group_input_value = WC()->session->get('gift_group_order_data');
$count_info                 = itg_check_quantity_gift_in_session(WC()->session->get('gift_group_order_data'), itg_get_cart_item_quantities_gift_stock());

$add_gift = get_option('itg_localization_add_gift', 'Add Gift');
$select_gift = get_option('itg_localization_select_gift', 'Select Gift');

foreach ($this->show_gift_item_for_cart as $gift_item_key => $gift) {
    if (isset($gift['auto']) && $gift['auto'] == 'yes') {
        continue;
    }

    $item_hover = 'hovering';
    $disable    = false;

    $flag_count = false;

    if (in_array($gift['method'], array(
        'buy_x_get_x_repeat',
    ), true) && $gift['base_q'] == 'ind') {
        if (array_key_exists($gift_item_key, $retrieved_group_input_value) && $retrieved_group_input_value[$gift_item_key]['q'] >= $this->gift_item_variable['all_gifts'][$gift_item_key]['q']) {
            $flag_count = true;
        }
    } elseif (array_key_exists($gift['uid'], $count_info['count_rule_gift']) && $count_info['count_rule_gift'][$gift['uid']]['q'] >= $gift['pw_number_gift_allowed']) {
        $flag_count = true;
    }

    if ($flag_count) {
        //if ( $gift['disable_if'] == 'hide' ) {
        //	continue;
        //} else {
        $item_hover = 'disable-hover';
        //}
    } elseif (in_array($gift['key'], $count_info['gifts_set']) && $gift['can_several_gift'] == 'no') {
        $item_hover = 'disable-hover';
    }

    $img_html = $title_html = '';
    $product  = wc_get_product($gift['item']);
    $title    = $product->get_title();
    if ($product->post_type == 'product_variation') {
        $title = $product->get_name();
    }
    $product_type = $product->get_type();

    /**  Check Quantity  **/
    $x          = '';
    $flag_stock = 0;

    $array_return   = itg_quantities_gift_stock($product, $this->product_qty_in_cart, $gift['item'], $product_type, $this->settings, $item_hover);
    $item_hover     = $array_return['item_hover'];
    $text_stock_qty = $array_return['text_stock_qty'];
    $stock_status = $array_return['stock_status'];

    $product_item .= '<tr class="wgb-product-item-cnt ' . esc_attr($item_hover) . ' ' . $stock_status . '">';
    $product_item .= '<td class="wgb-product-item-td-thumb">' . itg_render_product_image($product, false);
    if ($this->settings['show_stock_quantity'] == 'true') {
        $product_item .= '<span class="wgb-product-item-stock-in-thumb">' . $text_stock_qty . '</span>';
    }
    $product_item .= '</td>';
    $product_item   .= '<td><a href="' . get_permalink($gift['item']) . '">' . sprintf("%s", $title) . '</a></td>';
    if ($product_type == 'variable') {
        $gift_key = ($item_hover != 'disable-hover') ? $gift['item'] : '';
        $product_item .= '<td>
                                    <div class="wgb-add-gift-btn btn-select-gift-button" data-rule-id="' . esc_attr($gift['uid']) . '" data-id="' . esc_attr($gift_key) . '">
                                        <span>' . $select_gift . '</span>
                                        <div class="wgb-loading-icon wgb-d-none">
                                            <div class="wgb-spinner wgb-spinner--2"></div>
                                        </div>
                                    </div>
                                  </td>';
    } else {
        $gift_key = ($item_hover != 'disable-hover') ? $gift['key'] : '';
        $product_item .= '<td>
                                    <div class="wgb-add-gift-btn btn-add-gift-button" data-id="' . esc_attr($gift_key) . '">
                                        <span>' . $add_gift . '</span>
                                        <div class="wgb-loading-icon wgb-d-none">
                                            <div class="wgb-spinner wgb-spinner--2"></div>
                                        </div>
                                    </div>
                                  </td>';
    }

    $product_item .= '</tr>';
}

if ($product_item == '') {
    return;
}
?>
<div class="wgb-mt30 wgb-mb30">
    <h3><?php echo wp_kses_post("Choose Your Gift(s)", WGBL_NAME); ?></h3>
    <table class="it-gift-products-table display" style="width:100%">
        <thead>
            <tr>
                <th><?php _e('Thumb', WGBL_NAME); ?></th>
                <th><?php _e('Name', WGBL_NAME); ?></th>
                <th><?php _e('Add To Cart', WGBL_NAME); ?></th>
            </tr>
        </thead>
        <tbody>
            <?php echo wp_kses_post($product_item); ?>
        </tbody>
    </table>
</div>