<?php

/**
 * Validate field value
 * @var $products_ids
 * @var $uid
 * @var $gift_item_variable
 * @var $gift_rule_exclude
 * @var $product_qty_in_cart
 * @var $view
 * @var $settings
 */

$retrieved_group_input_value = WC()->session->get('gift_group_order_data');
$count_info = itg_check_quantity_gift_in_session($retrieved_group_input_value);

foreach ($products_ids as $product_id) :
    //For exclude in select variations
    if (isset($gift_rule_exclude[$uid]) && in_array(
        $product_id,
        $gift_rule_exclude[$uid]
    )) {
        continue;
    }
    $gift_id  = $uid . '-' . $product_id;
    $_product = wc_get_product($product_id);

    if ($_product->post_type == 'product_variation') {
        $title = $_product->get_name();
    } else {
        $title = $_product->get_title();
    }

    $product_type = $_product->get_type();
    $product_variable = false;
    if ($product_type == 'variable') {
        $product_variable = true;
    }
    $item_hover = 'hovering';

    if (in_array(
        $gift_id,
        $count_info['gifts_set']
    ) && $gift_item_variable[$uid]['can_several_gift'] == 'no') {
        $item_hover = 'disable-hover';
    }

    /**  Check Quantity  **/
    $array_return   = itg_quantities_gift_stock($_product, $product_qty_in_cart, $product_id, $product_type, $settings, $item_hover);
    $item_hover     = $array_return['item_hover'];
    $text_stock_qty = $array_return['text_stock_qty'];
    $stock_status = $array_return['stock_status'];
?>

    <div class="wgb-popup-post-item <?php echo esc_attr($item_hover); ?> <?php echo esc_attr($stock_status); ?>">
        <div class="wgb-popup-post-thumbnail">
            <?php itg_render_product_image($_product); ?>
            <?php if ($settings['show_stock_quantity'] == 'true') : ?>
                <span class="wgb-product-item-stock-in-thumb"><?php echo esc_html($text_stock_qty); ?></span>
            <?php endif; ?>
        </div>
        <a class="wgb-popup-post-title" href="<?php echo get_permalink($product_id); ?>"><?php echo sprintf("%s", $title); ?></a>
        <div class="wgb-popup-post-add-button">
            <div class="wgb-add-gift-btn btn-add-gift-button" data-id="<?php echo ($item_hover != 'disable-hover') ? esc_attr($gift_id) : ''; ?>">
                <div class="wgb-loading-icon wgb-d-none">
                    <div class="wgb-spinner wgb-spinner--2"></div>
                </div>
                <span><?php esc_html_e('Add Gift', WGBL_NAME); ?></span>
            </div>
        </div>
    </div>
<?php endforeach; ?>