<?php
$rule_id = (isset($rule_id)) ? $rule_id : 0;
$rule_item['method'] = (!empty($rule_item['method'])) ? $rule_item['method'] : 'simple';
?>

<div class="wgbl-rule-item <?php echo (!empty($rule_item['status']) && $rule_item['status'] == 'enable') ? 'wgbl-rule-enable' : 'wgbl-rule-disable'; ?>" data-id="<?php echo $rule_id; ?>">
    <input type="hidden" name="rule[<?php echo $rule_id; ?>][uid]" value="<?php echo sanitize_text_field($rule_item['uid']); ?>">
    <div class="wgbl-rule-header">
        <div class="wgbl-float-left">
            <button type="button" class="wgbl-rule-sortable-btn wgbl-button-tr" data-id="sort"><i class="dashicons dashicons-menu"></i></button>
            <h3 class="wgbl-rule-title"><?php echo sanitize_text_field($rule_item['rule_name']); ?></h3>
            <h4 class="wgbl-rule-method-name"><?php echo (!empty($rule_methods[$rule_item['method']])) ? sanitize_text_field($rule_methods[$rule_item['method']]) : esc_html_e('Unknown method', WGBL_NAME); ?></h4>
            <h4 class="wgbl-rule-method-id">ID: <?php echo sanitize_text_field($rule_item['uid']); ?> </h4>
        </div>
        <div class="wgbl-float-right">
            <select name="rule[<?php echo $rule_id; ?>][status]" class="wgbl-mr5 wgbl-rule-item-status">
                <option value="enable" <?php echo (!empty($rule_item['status']) && $rule_item['status'] == 'enable') ? 'selected' : ''; ?>><?php esc_html_e('Enable', WGBL_NAME); ?></option>
                <option value="disable" <?php echo (!empty($rule_item['status']) && $rule_item['status'] == 'disable') ? 'selected' : ''; ?>><?php esc_html_e('Disable', WGBL_NAME); ?></option>
            </select>
            <button type="button" class="wgbl-rule-duplicate wgbl-button-tr" data-id="duplicate"><i class="dashicons dashicons-admin-page"></i></button>
            <button type="button" class="wgbl-rule-delete wgbl-button-tr" data-id="delete"><i class="dashicons dashicons-no-alt"></i></button>
        </div>
    </div>
    <div class="wgbl-rule-body">
        <div class="wgbl-col-6">
            <div class="wgbl-form-group">
                <label><?php esc_html_e('Method', WGBL_NAME); ?></label>
                <select name="rule[<?php echo $rule_id; ?>][method]" class="wgbl-rule-method">
                <?php
                    if (!empty($rule_methods_grouped)) :
                        foreach ($rule_methods_grouped as $group) :
                            if (!empty($group['methods'])) :
                    ?>
                                <optgroup label="<?php echo sanitize_text_field($group['label']); ?>">
                                    <?php foreach ($group['methods'] as $method_key => $method_label) : ?>
                                        <option value="<?php echo sanitize_text_field($method_key); ?>" <?php echo ($rule_item['method'] == $method_key) ? 'selected' : ''; ?>><?php echo sanitize_text_field($method_label); ?></option>
                                    <?php endforeach; ?>
                                </optgroup>
                    <?php
                            endif;
                        endforeach;
                    endif;
                ?>
                </select>
            </div>
        </div>
        <div class="method-dependencies">
            <div class="wgbl-col-3" data-type="quantities-based-on" style="<?php echo (in_array($rule_item['method'], ['simple', 'subtotal', 'subtotal_repeat'])) ? 'display: none;' : ''; ?>">
                <div class="wgbl-form-group">
                    <label><?php esc_html_e('Quantities Based On', WGBL_NAME); ?></label>
                    <select name="rule[<?php echo $rule_id; ?>][quantities_based_on]" class="wgbl-quantities-based-on">
                        <optgroup label="Individual Products">
                            <option value="each_individual_product" <?php echo (!empty($rule_item['quantities_based_on']) && $rule_item['quantities_based_on'] == 'each_individual_product') ? 'selected' : ''; ?>><?php esc_html_e('Each individual product', WGBL_NAME); ?></option>
                            <option value="each_individual_variation" <?php echo (!empty($rule_item['quantities_based_on']) && $rule_item['quantities_based_on'] == 'each_individual_variation') ? 'selected' : ''; ?>><?php esc_html_e('Each individual variation - Pro version', WGBL_NAME); ?></option>
                            <option value="each_individual_cart_line_item" <?php echo (!empty($rule_item['quantities_based_on']) && $rule_item['quantities_based_on'] == 'each_individual_cart_line_item') ? 'selected' : ''; ?>><?php esc_html_e('Each individual cart line item - Pro version', WGBL_NAME); ?></option>
                        </optgroup>
                        <optgroup label="All Matched Products">
                            <option value="quantities_added_up_by_category" <?php echo (!empty($rule_item['quantities_based_on']) && $rule_item['quantities_based_on'] == 'quantities_added_up_by_category') ? 'selected' : ''; ?>><?php esc_html_e('Quantities added up by category - Pro version', WGBL_NAME); ?></option>
                            <option value="all_quantities_added_up" <?php echo (!empty($rule_item['quantities_based_on']) && $rule_item['quantities_based_on'] == 'all_quantities_added_up') ? 'selected' : ''; ?>><?php esc_html_e('All quantities added up - Pro version', WGBL_NAME); ?></option>
                        </optgroup>
                    </select>
                </div>
            </div>
            <div class="wgbl-col-3" data-type="rule_name">
                <div class="wgbl-form-group">
                    <label><?php esc_html_e('Rule name', WGBL_NAME); ?></label>
                    <input type="text" name="rule[<?php echo $rule_id; ?>][rule_name]" value="<?php echo sanitize_text_field($rule_item['rule_name']); ?>" placeholder="Rule name ..." class="wgbl-rule-name" required>
                </div>
            </div>
            <div class="wgbl-col-12" data-type="description">
                <div class="wgbl-form-group">
                    <label><?php esc_html_e('Description', WGBL_NAME); ?></label>
                    <input type="text" name="rule[<?php echo $rule_id; ?>][description]" value="<?php echo sanitize_text_field($rule_item['description']); ?>" placeholder="Description ...">
                </div>
            </div>
            <div class="wgbl-col-12" data-type="quantities">
                <div class="wgbl-rule-section">
                    <h3><?php esc_html_e('Quantities & Settings', WGBL_NAME); ?></h3>
                    <div class="wgbl-rule-section-content">
                        <div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-subtotal-amount" style="<?php echo (!in_array($rule_item['method'], ['subtotal', 'subtotal_repeat'])) ? 'display: none;' : ''; ?>">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Subtotal Amount', WGBL_NAME); ?></label>
                                <input type="number" min="0" name="rule[<?php echo $rule_id; ?>][quantity][subtotal_amount]" value="<?php echo (!empty($rule_item['quantity']['subtotal_amount'])) ? sanitize_text_field($rule_item['quantity']['subtotal_amount']) : ''; ?>">
                            </div>
                        </div>
                        <div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-buy" style="<?php echo (in_array($rule_item['method'], ['simple', 'subtotal', 'subtotal_repeat'])) ? 'display: none;' : ''; ?>">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Buy', WGBL_NAME); ?></label>
                                <input name="rule[<?php echo $rule_id; ?>][quantity][buy]" type="number" min="1" placeholder="Quantity" value="<?php echo (!empty($rule_item['quantity']['buy'])) ? sanitize_text_field($rule_item['quantity']['buy']) : ''; ?>" required <?php echo (in_array($rule_item['method'], ['simple', 'subtotal', 'subtotal_repeat'])) ? 'disabled' : ''; ?>>
                            </div>
                        </div>
                        <div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-get">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Get', WGBL_NAME); ?></label>
                                <input name="rule[<?php echo $rule_id; ?>][quantity][get]" type="number" min="1" placeholder="Quantity" value="<?php echo (!empty($rule_item['quantity']['get'])) ? sanitize_text_field($rule_item['quantity']['get']) : ''; ?>" required>
                            </div>
                        </div>
                        <div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-same-gift">
                            <div class="wgbl-form-group wgbl-checkbox-group">
                                <label><input type="checkbox" data-id="<?php echo $rule_id; ?>" data-name="same_gift" class="wgbl-rule-quantities-checkbox" <?php echo (!empty($rule_item['quantity']['same_gift']) && $rule_item['quantity']['same_gift'] == 'yes') ? 'checked="checked"' : ''; ?>> <?php esc_html_e('Same Gift', WGBL_NAME); ?></label>
                                <input type="hidden" name="rule[<?php echo $rule_id; ?>][quantity][same_gift]" value="<?php echo (!empty($rule_item['quantity']['same_gift']) && $rule_item['quantity']['same_gift'] == 'yes') ? 'yes' : 'no'; ?>">
                            </div>
                        </div>
                        <div class="wgbl-col-2-5 wgbl-quantity-item" data-type="quantities-auto-add-gift-to-cart">
                            <div class="wgbl-form-group wgbl-checkbox-group">
                                <label><input type="checkbox" data-id="<?php echo $rule_id; ?>" data-name="auto_add_gift_to_cart" class="wgbl-rule-quantities-checkbox" <?php echo (!empty($rule_item['quantity']['auto_add_gift_to_cart']) && $rule_item['quantity']['auto_add_gift_to_cart'] == 'yes') ? 'checked="checked"' : ''; ?>> <?php esc_html_e('Auto Add Gift - Pro version', WGBL_NAME); ?></label>
                                <input type="hidden" name="rule[<?php echo $rule_id; ?>][quantity][auto_add_gift_to_cart]" value="<?php echo (!empty($rule_item['quantity']['auto_add_gift_to_cart']) && $rule_item['quantity']['auto_add_gift_to_cart'] == 'yes') ? 'yes' : 'no'; ?>">
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="wgbl-col-12" data-type="product-buy" style="<?php echo (in_array($rule_item['method'], ['simple', 'subtotal', 'subtotal_repeat'])) ? 'display: none;' : ''; ?>">
                <div class="wgbl-rule-section">
                    <h3><?php esc_html_e('Products - Buy', WGBL_NAME); ?></h3>
                    <div class="wgbl-rule-section-content">
                        <div class="wgbl-product-buy-items">
                            <?php
                            if (!empty($rule_item['product_buy'])) :
                                $product_buy_id = 0;
                                foreach ($rule_item['product_buy'] as $product_buy_item) :
                                    include WGBL_VIEWS_DIR . 'rules/product-buy/row.php';
                                    $product_buy_id++;
                                endforeach;
                            endif;
                            ?>
                        </div>
                        <button type="button" class="wgbl-float-right wgbl-button wgbl-button-white-green wgbl-product-buy-add-product"><?php esc_html_e('Add Product', WGBL_NAME); ?></button>
                    </div>
                </div>
            </div>
            <div class="wgbl-col-12" data-type="get" style="<?php echo (in_array($rule_item['method'], ['buy_x_get_x', 'buy_x_get_x_repeat'])) ? 'display: none;' : ''; ?>">
                <div class="wgbl-rule-section">
                    <h3><?php esc_html_e('Get', WGBL_NAME); ?></h3>
                    <div class="wgbl-rule-section-content">
                        <div class="wgbl-col-6">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Include Products', WGBL_NAME); ?></label>
                                <select name="rule[<?php echo $rule_id; ?>][include_products][]" class="wgbl-select2-products-variations" data-type="select2" multiple data-placeholder="<?php esc_html_e('Select ...', WGBL_NAME); ?>" <?php echo (in_array($rule_item['method'], ['buy_x_get_x', 'buy_x_get_x_repeat'])) ? 'disabled' : ''; ?>>
                                    <?php
                                    if (!empty($rule_item['include_products']) && is_array($rule_item['include_products'])) :
                                        foreach ($rule_item['include_products'] as $product_id) :
                                            if (!empty($option_values['products'][$product_id])) :
                                    ?>
                                                <option value="<?php echo sanitize_text_field($product_id); ?>" selected><?php echo sanitize_text_field($option_values['products'][$product_id]) ?></option>
                                    <?php
                                            endif;
                                        endforeach;
                                    endif;
                                    ?>
                                </select>
                            </div>
                        </div>
                        <div class="wgbl-col-6">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Exclude Products', WGBL_NAME); ?></label>
                                <select name="rule[<?php echo $rule_id; ?>][exclude_products][]" class="wgbl-select2-products-variations" data-type="select2" multiple data-placeholder="<?php esc_html_e('Select ...', WGBL_NAME); ?>" <?php echo (in_array($rule_item['method'], ['buy_x_get_x', 'buy_x_get_x_repeat'])) ? 'disabled' : ''; ?>>
                                    <?php
                                    if (!empty($rule_item['exclude_products']) && is_array($rule_item['exclude_products'])) :
                                        foreach ($rule_item['exclude_products'] as $product_id) :
                                            if (!empty($option_values['products'][$product_id])) :
                                    ?>
                                                <option value="<?php echo sanitize_text_field($product_id); ?>" selected><?php echo sanitize_text_field($option_values['products'][$product_id]) ?></option>
                                    <?php
                                            endif;
                                        endforeach;
                                    endif;
                                    ?>
                                </select>
                            </div>
                        </div>
                        <div class="wgbl-col-6">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Include Category/Tag/Taxonomy', WGBL_NAME); ?></label>
                                <select name="rule[<?php echo $rule_id; ?>][include_taxonomy][]" class="wgbl-select2-taxonomies" multiple data-type="select2" data-placeholder="<?php esc_html_e('Select ...', WGBL_NAME); ?>" <?php echo (in_array($rule_item['method'], ['buy_x_get_x', 'buy_x_get_x_repeat'])) ? 'disabled' : ''; ?>>
                                    <?php
                                    if (!empty($rule_item['include_taxonomy']) && is_array($rule_item['include_taxonomy'])) :
                                        foreach ($rule_item['include_taxonomy'] as $taxonomy_id) :
                                            if (!empty($option_values['taxonomies'][$taxonomy_id])) :
                                    ?>
                                                <option value="<?php echo sanitize_text_field($taxonomy_id); ?>" selected><?php echo sanitize_text_field($option_values['taxonomies'][$taxonomy_id]) ?></option>
                                    <?php
                                            endif;
                                        endforeach;
                                    endif;
                                    ?>
                                </select>
                            </div>
                        </div>
                        <div class="wgbl-col-6">
                            <div class="wgbl-form-group">
                                <label><?php esc_html_e('Exclude Category/Tag/Taxonomy', WGBL_NAME); ?></label>
                                <select name="rule[<?php echo $rule_id; ?>][exclude_taxonomy][]" class="wgbl-select2-taxonomies" data-type="select2" multiple data-type="select2" data-placeholder="<?php esc_html_e('Select ...', WGBL_NAME); ?>" <?php echo (in_array($rule_item['method'], ['buy_x_get_x', 'buy_x_get_x_repeat'])) ? 'disabled' : ''; ?>>
                                    <?php
                                    if (!empty($rule_item['exclude_taxonomy']) && is_array($rule_item['exclude_taxonomy'])) :
                                        foreach ($rule_item['exclude_taxonomy'] as $taxonomy_id) :
                                            if (!empty($option_values['taxonomies'][$taxonomy_id])) :
                                    ?>
                                                <option value="<?php echo sanitize_text_field($taxonomy_id); ?>" selected><?php echo sanitize_text_field($option_values['taxonomies'][$taxonomy_id]) ?></option>
                                    <?php
                                            endif;
                                        endforeach;
                                    endif;
                                    ?>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="wgbl-col-12" data-type="conditions">
                <div class="wgbl-rule-section">
                    <h3><?php esc_html_e('Conditions', WGBL_NAME); ?></h3>
                    <div class="wgbl-rule-section-content">
                        <div class="wgbl-condition-items">
                            <?php
                            if (!empty($rule_item['condition'])) :
                                $condition_id = 0;
                                foreach ($rule_item['condition'] as $condition_item) :
                                    include WGBL_VIEWS_DIR . 'rules/conditions/row.php';
                                    $condition_id++;
                                endforeach;
                            endif;
                            ?>
                        </div>
                        <button type="button" class="wgbl-float-right wgbl-button wgbl-button-white-green wgbl-add-condition"><?php esc_html_e('Add Condition', WGBL_NAME); ?></button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>